package org.jvnet.hifaces.application;

import java.io.IOException;

import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jvnet.hifaces.io.util.TransientValue;

public class SessionStateManager extends javax.faces.application.StateManager {

	private static final Log log = LogFactory.getLog(SessionStateManager.class);

	@Override
	protected Object getComponentStateToSave(FacesContext facesContext) {
		return null;
	}

	@Override
	protected Object getTreeStructureToSave(FacesContext facesContext) {
		return null;
	}

	@Override
	protected void restoreComponentState(FacesContext context,
			UIViewRoot viewRoot, String renderKitId) {
	}

	@Override
	protected UIViewRoot restoreTreeStructure(FacesContext context,
			String viewId, String renderKitId) {
		return null;
	}

	@Override
	@SuppressWarnings("unchecked")
	public UIViewRoot restoreView(FacesContext facesContext, String viewId,
			String renderKitId) {

		final String viewRootKey = viewId;

		final TransientValue<UIViewRoot> viewRootAttribute =

		(TransientValue<UIViewRoot>) facesContext.getExternalContext()
				.getSessionMap().get(viewRootKey);

		if (viewRootAttribute != null) {
			final UIViewRoot viewRoot = viewRootAttribute.get();
			if (viewRoot == null)
				log.debug("View root was garbage collected");
			return viewRoot;
		} else {
			return null;
		}
	}

	@Override
	public SerializedView saveSerializedView(FacesContext facesContext) {

		final UIViewRoot viewRoot = facesContext.getViewRoot();

		final TransientValue<UIViewRoot> viewRootAttribute = new TransientValue<UIViewRoot>(
				viewRoot);

		final String viewId = viewRoot.getViewId();

		final String viewRootKey = viewId;

		facesContext.getExternalContext().getSessionMap().put(viewRootKey,
				viewRootAttribute);

		return null;
	}

	@Override
	public void writeState(FacesContext context, SerializedView state)
			throws IOException {

		// Nothing to do.
	}

}
