package org.jvnet.hifaces.binding;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.MethodNotFoundException;
import javax.faces.el.PropertyNotFoundException;

public abstract class VariableMethodBinding extends MethodBinding {

  private final String var;

  public VariableMethodBinding(String var) {
    this.var = var;
  }

  public Object invoke(FacesContext facesContext, Object[] arguments)
      throws EvaluationException,
      MethodNotFoundException {
    final Object value = facesContext.getApplication().getVariableResolver().resolveVariable(
        facesContext,
        var);
    return invoke(value);
  }

  public abstract Object invoke(Object var);

  public Class getType(FacesContext facesContext)
      throws EvaluationException,
      PropertyNotFoundException {
    return Object.class;
  }

}
