package org.jvnet.hifaces.model.paging;

import java.util.List;

/**
 * Abstract data page class.
 * 
 * @author valikov
 * @param <T>
 *            Type of the entry.
 */
public abstract class AbstractDataPage<T> implements DataPage<T> {

	private final int start;

	private final List<T> data;

	public AbstractDataPage(int start, List<T> data) {
		this.start = start;
		this.data = data;
	}

	public int getStart() {
		return start;
	}

	public List<T> getData() {
		return data;
	}

}
