package org.jvnet.hifaces.util;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

public class CookieUtils {

	private CookieUtils() {

	}

	public static boolean isCookiesEnabled() {
		return isCookiesEnabled(FacesContext.getCurrentInstance());
	}

	public static boolean isCookiesEnabled(FacesContext context) {
		if (context == null) {
			return false;
		} else {
			final Object draftRequest = context.getExternalContext()
					.getRequest();
			if (draftRequest instanceof HttpServletRequest) {
				final HttpServletRequest request = (HttpServletRequest) draftRequest;
				return request.isRequestedSessionIdFromCookie();
			} else {
				return false;
			}
		}
	}
}
