package org.jvnet.hifaces.util;

import javax.faces.component.html.HtmlSelectBooleanCheckbox;
import javax.faces.component.html.HtmlSelectManyCheckbox;
import javax.faces.component.html.HtmlSelectManyListbox;
import javax.faces.component.html.HtmlSelectOneMenu;
import javax.faces.component.html.HtmlSelectOneRadio;
import javax.faces.el.ValueBinding;

import org.apache.myfaces.custom.picklist.HtmlSelectManyPicklist;

public class SelectUtils {

	private SelectUtils() {

	}

	public static HtmlSelectOneMenu createSelectOneMenu() {
		final HtmlSelectOneMenu selectOneMenu = new HtmlSelectOneMenu();
		IdUtils.assignId(selectOneMenu);
		return selectOneMenu;
	}

	public static HtmlSelectManyCheckbox createSelectManyCheckbox() {
		final HtmlSelectManyCheckbox selectManyCheckbox = new HtmlSelectManyCheckbox();
		IdUtils.assignId(selectManyCheckbox);
		selectManyCheckbox.setLayout("pageDirection");
		return selectManyCheckbox;
	}

	public static HtmlSelectOneRadio createSelectOneRadio() {
		final HtmlSelectOneRadio selectOneRadio = new HtmlSelectOneRadio();
		IdUtils.assignId(selectOneRadio);
		return selectOneRadio;
	}

	public static HtmlSelectManyPicklist createSelectManyPicklist() {
		final HtmlSelectManyPicklist selectMany = new HtmlSelectManyPicklist();
		IdUtils.assignId(selectMany);
		selectMany
				.setRendererType(HtmlSelectManyPicklist.DEFAULT_RENDERER_TYPE);
		selectMany.setSize(4);
		return selectMany;
	}

	public static HtmlSelectManyListbox createSelectManyListbox() {
		final HtmlSelectManyListbox selectManyListbox = new HtmlSelectManyListbox();
		IdUtils.assignId(selectManyListbox);
		return selectManyListbox;
	}

	public static HtmlSelectBooleanCheckbox createSelectBooleanCheckbox() {
		final HtmlSelectBooleanCheckbox checkBox = new HtmlSelectBooleanCheckbox();
		IdUtils.assignId(checkBox);
		return checkBox;
	}

	public static HtmlSelectBooleanCheckbox createSelectBooleanCheckbox(
			ValueBinding valueBinding) {
		final HtmlSelectBooleanCheckbox checkBox = createSelectBooleanCheckbox();
		checkBox.setValueBinding("value", valueBinding);
		return checkBox;
	}

}
